﻿using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;
using MD2x;

namespace PANDA_II_I2C_MD25
{
    public class Program
    {
        public static void Main()
        {
            // Programme de test de la carte MD23/MD25
            // Création d'un objet MotorControl (carte MD23 ou MD25)
            // avec l'adresse 0x58 et la fréquence de bus F = 100kHz
            MotorControlMD2x CarteMD23 = new MotorControlMD2x();

            // Lecture des registres de la carte MD2x et affichage de la version du logiciel
            Debug.Print("Vers.=" + CarteMD23.SoftRev.ToString());            
            Debug.Print("Tension="+((Single)CarteMD23.Battery/10).ToString("N1")+"V");
            Debug.Print("Acceleration=" + CarteMD23.AccelerationRate.ToString());
            Debug.Print("Mode=" + CarteMD23.Mode.ToString()); 

            while (true)
            {
                // Essai 1: Rotation des moteurs pendant 2s
                // ---------------------------------------------------------------------
                CarteMD23.SetSpeedTurn(140, 140); // Réglage de la vitesse des moteurs
                Thread.Sleep(2000); // Rotation pendant 2s
                // Lecture des registres et affichage de la valeur des codeurs
                Debug.Print("Codeur 1=" + CarteMD23.Encoder1.ToString() + " " + "Codeur 2=" + CarteMD23.Encoder2.ToString());
                CarteMD23.StopMotor(); // Arrêt des moteurs
                Thread.Sleep(3000);

                // Essai 2 : Rotation des moteurs jusqu'à ce que la distance recherchée soit atteinte
                // ---------------------------------------------------------------------
                CarteMD23.RazEncoders(); // Remise à zéro des codeurs
                CarteMD23.SetSpeedTurn(140, 140); // Réglage de la vitesse des moteurs

                while (CarteMD23.Encoder1 < 2000) 
                {
                    Debug.Print("Codeur 1=" + CarteMD23.Encoder1.ToString() + " " + "Codeur 2=" + CarteMD23.Encoder2.ToString());  
                }
                CarteMD23.StopMotor();  // Arrêt des moteurs
                Thread.Sleep(5000);
            }          
        }
    }
}
